/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VNovariableRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VNovariable extends TableImpl<VNovariableRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_novariable</code>
     */
    public static final VNovariable V_NOVARIABLE = new VNovariable();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VNovariableRecord> getRecordType() {
        return VNovariableRecord.class;
    }

    /**
     * The column <code>common_dd.v_novariable.key_element</code>.
     */
    public final TableField<VNovariableRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_novariable.key_element_type</code>.
     */
    public final TableField<VNovariableRecord, Integer> KEY_ELEMENT_TYPE = createField(DSL.name("key_element_type"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_novariable.key_parent_element</code>.
     */
    public final TableField<VNovariableRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_novariable.dn</code>.
     */
    public final TableField<VNovariableRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_novariable.order_nr</code>.
     */
    public final TableField<VNovariableRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_novariable.short_name</code>.
     */
    public final TableField<VNovariableRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_novariable.is_public</code>.
     */
    public final TableField<VNovariableRecord, Integer> IS_PUBLIC = createField(DSL.name("is_public"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_novariable.hier_lang</code>.
     */
    public final TableField<VNovariableRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    private VNovariable(Name alias, Table<VNovariableRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VNovariable(Name alias, Table<VNovariableRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_novariable" as  SELECT key_element,
          key_element_type,
          key_parent_element,
          dn,
          order_nr,
          short_name,
          is_public,
          hier_lang
         FROM common_dd.t_core_element_hierarchy
        WHERE (NOT (key_element IN ( SELECT t_core_variable.key_variable
                 FROM common_dd.t_core_variable)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_novariable</code> table reference
     */
    public VNovariable(String alias) {
        this(DSL.name(alias), V_NOVARIABLE);
    }

    /**
     * Create an aliased <code>common_dd.v_novariable</code> table reference
     */
    public VNovariable(Name alias) {
        this(alias, V_NOVARIABLE);
    }

    /**
     * Create a <code>common_dd.v_novariable</code> table reference
     */
    public VNovariable() {
        this(DSL.name("v_novariable"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VNovariable as(String alias) {
        return new VNovariable(DSL.name(alias), this);
    }

    @Override
    public VNovariable as(Name alias) {
        return new VNovariable(alias, this);
    }

    @Override
    public VNovariable as(Table<?> alias) {
        return new VNovariable(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VNovariable rename(String name) {
        return new VNovariable(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VNovariable rename(Name name) {
        return new VNovariable(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VNovariable rename(Table<?> name) {
        return new VNovariable(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VNovariable where(Condition condition) {
        return new VNovariable(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VNovariable where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VNovariable where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VNovariable where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VNovariable where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VNovariable where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VNovariable where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VNovariable where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VNovariable whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VNovariable whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
